#!/usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const cmd_ts_1 = require("cmd-ts");
const restore_1 = __importDefault(require("./cmds/restore"));
const hook_1 = __importDefault(require("./cmds/hook"));
const rehook_1 = __importDefault(require("./cmds/rehook"));
const purge_1 = __importDefault(require("./cmds/purge"));
const app = (0, cmd_ts_1.subcommands)({
    name: "PP-Finder",
    description: "Find prototype pollution gadget in javascript code",
    cmds: {
        hook: hook_1.default,
        rehook: rehook_1.default,
        restore: restore_1.default,
        purge: purge_1.default,
    },
});
function main() {
    return __awaiter(this, void 0, void 0, function* () {
        yield (0, cmd_ts_1.run)(app, process.argv.slice(2));
    });
}
if (require.main === module) {
    main();
}
