"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.initPPFinder = void 0;
const os_1 = __importDefault(require("os"));
const path_1 = __importDefault(require("path"));
const fs_extra_1 = __importDefault(require("fs-extra"));
const errors_1 = require("./errors");
function saveBackupFile(path, db) {
    fs_extra_1.default.writeJSONSync(path, Object.fromEntries(db.entries()));
}
function loadBackupFile(path) {
    try {
        const str = fs_extra_1.default.readFileSync(path, { encoding: "utf-8" });
        if (str === "")
            return new Map();
        return new Map(JSON.parse(str).entries());
    }
    catch (_a) {
        throw new errors_1.InvalidBackupError();
    }
}
function createBackupManager(configFolder) {
    const db = loadBackupFile(path_1.default.join(configFolder, "backup.json"));
    return {
        save(path) {
            if (fs_extra_1.default.statSync(path).isDirectory()) {
                throw new errors_1.UnimplementedError();
            }
        },
        restore(path) { },
    };
}
function initPPFinder() {
    return __awaiter(this, void 0, void 0, function* () {
        const home = os_1.default.homedir();
        const backupPath = path_1.default.join(home, ".local/share/pp-finder");
        const db = createBackupManager(backupPath);
        db.save('/home/bitk/secu/audit/proto-pollution/vm2/src/index.js');
        console.log(db);
    });
}
exports.initPPFinder = initPPFinder;
