import ts from "typescript";
export interface PPArgs {
    module: "classic" | "minimal";
    hookMode: "inline" | "require";
    path: string;
    wrapperName: string;
}
export declare type Location = [number, number];
export interface Compiler {
    compile(filename: string, source: string): string;
}
export declare type ExpressionType = "ForIn" | "IsIn" | "Prop" | "Elem" | "Bind";
export declare type PPLogger = (expressionType: ExpressionType, location: [number, number], key?: string) => void;
export declare type PPTransformer = (node: ts.Node, utils: PPTransformerUtils) => ts.Node | null;
export declare type PPTransformerUtils = {
    wrapperName: string;
    visit: <U extends ts.Node>(n: U) => U;
    createWrapperCall: (name: string, target: ts.Node, params: ts.Expression[]) => ts.CallExpression;
};
